﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr158_1
{
    // Базовый абстрактный класс: 
    abstract class Base {
        // Объявление абстрактного свойства: 
        public abstract int number { 
            get; 
            set;
        }
        // Конструктор с одним аргументом: 
        public Base(int n) {
            // Присваивание значения свойству: 
            number = n;
            // Вызывается обычный (не абстрактный) метод: 
            show();
        }
        // Описание обычного (не абстрактного) метода: 
        public void show() {
            // Отображение значения свойства: 
            Console.WriteLine("Свойство number = " + number);
        }
    }

    // Первый интерфейс:
    interface First {
        // Объявление методов: 
        void setNum(int n); 
        int getNum();
    }

    // Второй интерфейс:
    interface Second {
        // Объявление индексатора: 
        int this[int k]{ 
            get;
        }
    }

    // Класс реализует интерфейс:
    class MyClass: Base, First, Second {
        // Закрытое целочисленное поле: 
        private int num;
        // Конструктор с одним аргументом: 
        public MyClass(int n): base(n) {}
        // Описание метода из интерфейса First: 
        public void setNum(int n) {
            // Присваивание значения полю: 
            num = n;
        }
        // Описание метода из интерфейса First: 
        public int getNum() {
            // Значение поля: 
            return num;
        }
        // Описание свойства из класса Base: 
        public override int number {
            // Аксессор для считывания значения: 
            get {
                // Вызывается метод из интерфейса First: 
                return getNum();
            }
            // Аксессор для присваивания значения: 
            set {
                // Вызывается метод из интерфейса First: 
                setNum(value);
            }
        }
        // Описание индексатора из интерфейса Second: 
        public int this[int k] {
            // Аксессор для считывания значения: 
            get {
                // Локальная переменная: 
                int r = number;
                // "Отбрасывание" цифр в десятичном 
                // представлении числа: 
                for(int i = 0; i < k; i++) { 
                    r /= 10;
                }
                // Результат: 
                return r % 10;
            }
        }
    }

    // Класс с главным методом:
    class Program
    {
        static void Main()
        {
            int m = 9;
            MyClass obj = new MyClass(12345); 
            for (int i = 0; i <= m; i++)
            {
                Console.Write("|" + obj[m - i]);
            }
            Console.WriteLine("|");
            // Задержка:
            Console.ReadLine();
        }
    }
}
